﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace cGFXShift
{
    public partial class cGFXShift : Form
    {
        int grid = 3;
        int offx = 0;
        int offy = 0;
        int imgx = 0;
        int imgy = 0;
        Image bgfx;
        String filename;

        public cGFXShift()
        {
            InitializeComponent();
            lblGrid.Text="Grid " + grid + "x" + grid;
            lblImgSize.Text="X=0 Y=0";
            lblOffset.Text = "Offset X=" + offx + " Y=" + offy;
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
        }

        private void ShowInfo()
        {
            float cox=0;
            float coy=0;
            cox = (float) -(offx * 0.03125);
            coy = (float) -(offy * 0.03125);
            //Console.WriteLine("grid" + grid + " X" + offx + "|" + cox.ToString() + " Y" + offy + "|" + coy);
            lblGrid.Text = "Grid " + grid + "x" + grid;
            lblImgSize.Text = "X=" + imgx + " Y=" + imgy;
            lblOffset.Text = "Offset X=" + cox + " Y=" + coy;            
            //lblOffset.Text = "X=" + imgx + " Y=" + imgy + " ... Grid " + grid + "x" + grid + " ... Offset X=" + cox + " Y=" + coy;
            Refresh();
        }

        private void cmdPicLoad_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "*.png";
            openFileDialog1.Filter = "|*.png";
            openFileDialog1.ShowDialog();
            try
            {
                bgfx = Image.FromFile(openFileDialog1.FileName);
                filename = openFileDialog1.FileName;
                pictureBox1.Image = bgfx;
                imgx = bgfx.Width;
                imgy = bgfx.Height;
                cmdGridPlus.Enabled = true;
                cmdGridMinus.Enabled = true;
                ShowInfo();
            }
            catch (Exception)
            {
                // display error and abort
            }
        }

        private void cmdGridPlus_Click(object sender, EventArgs e)
        {
            grid++;
            if (grid > 10) { grid = 10; }
            ShowInfo();
        }

        private void cmdGridMinus_Click(object sender, EventArgs e)
        {
            grid--;
            if (grid < 1) { grid = 1; }
            ShowInfo();
        }

        private void cmdReset_Click(object sender, EventArgs e)
        {
            grid = 3;
            offx = 0;
            offy = 0;
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            // black border
            Pen blackPen = new Pen(Color.Black, 1);
            e.Graphics.DrawRectangle(blackPen, 0, 0, imgx, imgy);

            int gc = grid * 16;
            int sx = (int)Math.Round(imgx * 0.5) - gc;
            int sy = (int)Math.Round(imgy * 0.5) - gc;

            //Console.WriteLine("grid" + grid + " X" + sx + " Y" + sy + " gc" + gc + " ix" + imgx);

            // paint grid
            Pen yellowPen = new Pen(Color.Orange, 2);
            for (int ylop = 0; ylop < grid; ylop++)
            {
                for (int xlop = 0; xlop < grid; xlop++)
                {
                    int xp = (xlop * 32) + offx + sx;
                    int yp = (ylop * 32) + offy + sy;
                    e.Graphics.DrawRectangle(yellowPen, xp, yp, 32, 32);
                }
            }
        }

        private void cmdGridUp_Click(object sender, EventArgs e)
        {
            offy--;
            ShowInfo();
        }

        private void cmdGridDown_Click(object sender, EventArgs e)
        {
            offy++;
            ShowInfo();
        }

        private void cmdGridLeft_Click(object sender, EventArgs e)
        {
            offx--;
            ShowInfo();
        }

        private void cmdGridRight_Click(object sender, EventArgs e)
        {
            offx++;
            ShowInfo();
        }

        private void cmdGridFastUp_Click(object sender, EventArgs e)
        {
            offy = offy - 4;
            ShowInfo();
        }

        private void cmdGridFastDown_Click(object sender, EventArgs e)
        {
            offy = offy + 4;
            ShowInfo();
        }

        private void cmdGridFastLeft_Click(object sender, EventArgs e)
        {
            offx = offx - 4;
            ShowInfo();
        }

        private void cmdGridFastRight_Click(object sender, EventArgs e)
        {
            offx = offx + 4;
            ShowInfo();
        }
    }
}
